Index: /trunk/src/sh_unix.c
===================================================================
--- /trunk/src/sh_unix.c	(revision 584)
+++ /trunk/src/sh_unix.c	(revision 1)
@@ -25,7 +25,5 @@
 #include <string.h>
 #include <ctype.h>
-#ifdef HAVE_LINUX_FS_H
-#include <linux/fs.h>
-#endif
+
 
 #ifdef HAVE_MEMORY_H
@@ -43,10 +41,4 @@
 #include <fcntl.h>
 #include <unistd.h>
-/* need to undef these, since the #define's may be picked up from
- * linux/wait.h, and will clash with a typedef in sys/wait.h
- */
-#undef P_ALL
-#undef P_PID
-#undef P_PGID
 #include <sys/wait.h>
 
@@ -58,8 +50,14 @@
 #endif
 
+#if TIME_WITH_SYS_TIME
+#include <sys/time.h>
+#include <time.h>
+#else
 #if HAVE_SYS_TIME_H
 #include <sys/time.h>
-#endif
+#else
 #include <time.h>
+#endif
+#endif
 
 #ifdef HAVE_SYS_SELECT_H
@@ -77,5 +75,5 @@
 #endif
 #ifndef FD_ZERO
-#define FD_ZERO(p)      memset((char *)(p), 0, sizeof(*(p)))
+#define FD_ZERO(p)      memset((char *)(p), '\0', sizeof(*(p)))
 #endif
 
@@ -92,10 +90,6 @@
 #include "sh_hash.h"
 #include "sh_tools.h"
-#include "sh_restrict.h"
-#include "sh_ipvx.h"
 #include "sh_tiger.h"
 #include "sh_prelink.h"
-#include "sh_pthread.h"
-#include "sh_sem.h"
 
 /* moved here from far below
@@ -127,22 +121,4 @@
 #endif
 
-#if defined(S_IFDOOR) && !defined(S_ISDOOR)
-#define S_ISDOOR(mode) (((mode) & S_IFMT) == S_IFDOOR)
-#else
-#if !defined(S_ISDOOR)
-#define S_ISDOOR(mode) (0)
-#endif
-#endif
-
-#if defined(S_IFPORT) && !defined(S_ISPORT)
-#define S_ISPORT(mode) (((mode) & S_IFMT) == S_IFPORT)
-#else
-#if !defined(S_ISPORT)
-#define S_ISPORT(mode) (0)
-#endif
-#endif
-
-#define SH_KEY_NULL _("000000000000000000000000000000000000000000000000")
-
 #undef  FIL__
 #define FIL__  _("sh_unix.c")
@@ -151,7 +127,4 @@
 unsigned long mask_USER0        = MASK_USER_;
 unsigned long mask_USER1        = MASK_USER_;
-unsigned long mask_USER2        = MASK_USER_;
-unsigned long mask_USER3        = MASK_USER_;
-unsigned long mask_USER4        = MASK_USER_;
 unsigned long mask_ALLIGNORE    = MASK_ALLIGNORE_;
 unsigned long mask_ATTRIBUTES   = MASK_ATTRIBUTES_;
@@ -169,7 +142,4 @@
   mask_USER0        = MASK_USER_;
   mask_USER1        = MASK_USER_;
-  mask_USER2        = MASK_USER_;
-  mask_USER3        = MASK_USER_;
-  mask_USER4        = MASK_USER_;
   mask_ALLIGNORE    = MASK_ALLIGNORE_;
   mask_ATTRIBUTES   = MASK_ATTRIBUTES_;
@@ -337,6 +307,6 @@
     *p = '0' + (u % 10);
     u /= 10;
-  } while (u && (p != str));
-  if ((iisneg == 1) && (p != str)) {
+  } while (u);
+  if (iisneg == 1) {
     --p;
     *p = '-';
@@ -353,7 +323,7 @@
 extern int OnlyStderr; 
 
-int safe_logger (int thesignal, int method, char * details)
-{
-  unsigned int i = 0;
+int safe_logger (int signal, int method, pid_t thepid)
+{
+  int i = 0;
   int status = -1;
   struct stat buf;
@@ -361,19 +331,17 @@
   char  str[128];
   char  * p;
-  
+
   char l0[64], l1[64], l2[64], l3[64];
-  char a0[32];
+  char a0[32], a1[32], a2[32];
   char e0[128];
   char msg[128];
-  
+
   char * locations[] = { NULL, NULL, NULL, NULL, NULL };
   char * envp[]      = { NULL, NULL };
-  char * argp[]      = { NULL, NULL, NULL };
-  
-  pid_t  thepid = getpid();
-  
+  char * argp[]      = { NULL, NULL, NULL, NULL, NULL };
+
   if ((sh.flag.isdaemon == S_FALSE) || (OnlyStderr == S_TRUE))
     method = 1;
-  
+
   /* seems that solaris cc needs this way of initializing ...
    */
@@ -382,25 +350,35 @@
   locations[2] = l2;
   locations[3] = l3;
-  
+
   envp[0] = e0;
+
   argp[0] = a0;
-  
+  argp[1] = a1;
+  argp[2] = a2;
+
+  strcpy (l0, _("/usr/bin/logger"));                   /* known to fit  */
+  strcpy (l1, _("/usr/sbin/logger"));                  /* known to fit  */
+  strcpy (l2, _("/usr/ucb/logger"));                   /* known to fit  */
+  strcpy (l3, _("/bin/logger"));                       /* known to fit  */
+
+  strcpy (a0, _("logger"));                            /* known to fit  */
+  strcpy (a1, _("-p"));                                /* known to fit  */
+  strcpy (a2, _("daemon.alert"));                      /* known to fit  */
+
+  strcpy (e0,                                          /* known to fit  */
+	  _("PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/ucb:/usr/local/bin"));
+
   sl_strlcpy(msg, _("samhain["), 128);
   p = safe_itoa((int) thepid, str, 128);
   if (p && *p)
     sl_strlcat(msg, p, 128);
-  if (thesignal == 0)
-    {
-      if (details == NULL) {
-	sl_strlcat(msg, _("]: out of memory"), 128);
-      } else {
-	sl_strlcat(msg, _("]: "), 128);
-	sl_strlcat(msg, details, 128);
-      }
+  if (signal == 0)
+    {
+      sl_strlcat(msg, _("]: out of memory"), 128);
     }
   else 
     {
       sl_strlcat(msg, _("]: exit on signal "), 128);
-      p = safe_itoa(thesignal, str, 128);
+      p = safe_itoa(signal, str, 128);
       if (p && *p)
 	sl_strlcat(msg, p, 128);
@@ -411,24 +389,8 @@
 #define STDERR_FILENO 2
 #endif
-    int retval = 0;
-    do {
-      retval = write(STDERR_FILENO,  msg, strlen(msg));
-    } while (retval < 0 && errno == EINTR);
-    do {
-      retval = write(STDERR_FILENO, "\n", 1);
-    } while (retval < 0 && errno == EINTR);
+    write(STDERR_FILENO,  msg, strlen(msg));
+    write(STDERR_FILENO, "\n", 1);
     return 0;
   }
-
-  sl_strlcpy (l0, _("/usr/bin/logger"), 64);
-  sl_strlcpy (l1, _("/usr/sbin/logger"), 64);
-  sl_strlcpy (l2, _("/usr/ucb/logger"), 64);
-  sl_strlcpy (l3, _("/bin/logger"), 64);
-
-  sl_strlcpy (a0, _("logger"), 32);
-  sl_strlcpy (e0,
-	      _("PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/ucb:/usr/local/bin"),
-	      128);
-
   while (locations[i] != NULL) {
     status = stat(locations[i], &buf);
@@ -439,5 +401,5 @@
 
   if (locations[i] != NULL) {
-    argp[1] = msg;
+    argp[3] = msg;
     newpid = fork();
     if (newpid == 0) {
@@ -452,27 +414,4 @@
 }
 
-void safe_fatal (const char * details, 
-		 const char * file, int line)
-{
-  char msg[128];
-  char str[128];
-  char * p;
-  int  thesignal = 0;
-  int  method = 0;
-
-  p = safe_itoa((int) line, str, 128);
-  sl_strlcpy(msg, _("FATAL: "), 128);
-  sl_strlcat(msg, file, 128);
-  sl_strlcat(msg, ": ", 128);
-  if (p && (*p)) {
-    sl_strlcat(msg, p   , 128);
-    sl_strlcat(msg, ": ", 128);
-  }
-  sl_strlcat(msg, details, 128);
-  (void) safe_logger (thesignal, method, msg);
-
-  close_ipc ();
-  raise(SIGKILL);
-}
 
 extern char sh_sig_msg[64];
@@ -508,17 +447,11 @@
       ++immediate_exit_normal;
       if ((skey != NULL) && (immediate_exit_normal == 2))
-	memset (skey, 0, sizeof(sh_key_t));
+	memset (skey, '\0', sizeof(sh_key_t));
       if (immediate_exit_normal == 2)
 	{
-	  int val_return;
-
-	  do {
-	    val_return = chdir ("/");
-	  } while (val_return < 0 && errno == EINTR);
-
-          close_ipc ();
-	  safe_logger (mysignal, 0, NULL);
+	  chdir ("/");
+	  safe_logger (mysignal, 0, getpid());
 	}
-      raise(SIGKILL);
+      _exit(mysignal);
     }
   else
@@ -551,8 +484,4 @@
 #endif
 {
-#if defined(SL_DEBUG) && (defined(USE_SYSTEM_MALLOC) || !defined(USE_MALLOC_LOCK))
-  int retval;
-#endif
-
 #if defined(SA_SIGACTION_WORKS)
   if (signal_info != NULL && signal_info->si_code == SI_USER)
@@ -570,11 +499,11 @@
   /* Check whether the heap is ok; otherwise _exit 
    */
-#if !defined(SL_DEBUG) || (!defined(USE_SYSTEM_MALLOC) && defined(USE_MALLOC_LOCK))
+#if !defined(SL_DEBUG)
   ++immediate_exit_fast;
   if (skey != NULL && immediate_exit_fast < 2)
-    memset (skey, 0, sizeof(sh_key_t));
+    memset (skey, '\0', sizeof(sh_key_t));
   if (immediate_exit_fast < 2)
-    safe_logger (mysignal, 0, NULL);
-  raise(SIGKILL);
+    safe_logger (mysignal, 0, getpid());
+  _exit(mysignal);
 #else
 
@@ -585,22 +514,20 @@
       ++immediate_exit_fast;
       if (skey != NULL)
-	memset (skey, 0, sizeof(sh_key_t));
+	memset (skey, '\0', sizeof(sh_key_t));
+#ifdef WITH_MESSAGE_QUEUE
       close_ipc ();
-      safe_logger (mysignal, 0, NULL);
-      do {
-	retval = chdir ("/");
-      } while (retval < 0 && errno == EINTR);
+#endif
+      safe_logger (mysignal, 0, getpid());
+      chdir ("/");
       raise(SIGFPE);
     }
   else if (immediate_exit_fast == 2)
     {
-      do {
-	retval = chdir ("/");
-      } while (retval < 0 && errno == EINTR);
+      chdir ("/");
       raise(SIGFPE);
     }
   else if (immediate_exit_fast != 0)
     {
-      raise(SIGKILL);
+      _exit(mysignal);
     }
 
@@ -615,5 +542,4 @@
   strncpy (sh_sig_msg, sh_unix_siglist(mysignal), 40);
 #endif
-  sh_sig_msg[63] = '\0';
 
   sl_stack_print();
@@ -625,11 +551,10 @@
 
   if (skey != NULL)
-    memset (skey, 0, sizeof(sh_key_t));
+    memset (skey, '\0', sizeof(sh_key_t));
+#ifdef WITH_MESSAGE_QUEUE
   close_ipc ();
-
-  do {
-    retval = chdir ("/");
-  } while (retval < 0 && errno == EINTR);
-
+#endif
+
+  chdir ("/");
   raise(SIGFPE);
 #endif
@@ -648,5 +573,5 @@
   if (mysignal == SIGUSR2)
     {
-      ++sig_suspend_switch;
+      sig_suspend_switch    = 1;
       ++sig_urgent;
     }
@@ -657,14 +582,6 @@
 #endif
 #ifdef SIGTTOU
-  if (mysignal == SIGTTOU) {
-    sig_force_check = 1; sh_sem_trylock(); }
-#endif
-#ifdef SIGTSTP
-  if (mysignal == SIGTSTP) {
-    sig_force_check = 1; sig_force_silent = 1; sh_sem_trylock(); }
-#endif
-#ifdef SIGTTIN
-  if (mysignal == SIGTTIN)
-    sig_fresh_trail = 1;
+  if (mysignal == SIGTTOU)
+    sig_force_check = 1;
 #endif
 #ifdef SIGABRT
@@ -674,5 +591,8 @@
 #ifdef SIGQUIT
   if (mysignal == SIGQUIT)
-    sig_terminate       = 1;
+    {
+      sig_terminate         = 1;
+      ++sig_urgent;
+    }
 #endif
 #ifdef SIGTERM
@@ -688,18 +608,4 @@
 }
 
-void sh_unix_ign_sigpipe()
-{
-  struct sigaction ignact;
-
-  ignact.sa_handler = SIG_IGN;            /* signal action           */
-  sigemptyset( &ignact.sa_mask );         /* set an empty mask       */
-  ignact.sa_flags = 0;                    /* init sa_flags           */
-
-#ifdef SIGPIPE
-  retry_sigaction(FIL__, __LINE__, SIGPIPE,   &ignact, NULL);
-#endif
-
-  return;
-}
 static
 void sh_unix_siginstall (int goDaemon)
@@ -808,5 +714,5 @@
 #endif
 #ifdef SIGTERM
-  retry_sigaction(FIL__, __LINE__, SIGTERM,    &act,  &oldact);
+  retry_sigaction(FIL__, __LINE__, SIGTERM,     &act,  &oldact);
 #endif
 
@@ -834,10 +740,15 @@
 #endif
 #ifdef SIGPIPE
-  retry_sigaction(FIL__, __LINE__, SIGPIPE,   &ignact, &oldact);
+  retry_sigaction(FIL__, __LINE__, SIGPIPE,      &act, &oldact);
 #endif
 #ifdef SIGALRM
   retry_sigaction(FIL__, __LINE__, SIGALRM,   &ignact, &oldact);
 #endif
-
+#ifdef SIGTSTP
+  retry_sigaction(FIL__, __LINE__, SIGTSTP,   &ignact, &oldact);
+#endif
+#ifdef SIGTTIN
+  retry_sigaction(FIL__, __LINE__, SIGTTIN,   &ignact, &oldact);
+#endif
 #if defined (SH_WITH_CLIENT) || defined (SH_STANDALONE)
 #ifdef SIGTTOU
@@ -847,25 +758,7 @@
     retry_sigaction(FIL__, __LINE__, SIGTTOU,   &ignact, &oldact);
 #endif
-#ifdef SIGTSTP
-  if (goDaemon == 1)
-    retry_sigaction(FIL__, __LINE__, SIGTSTP,     &act2, &oldact);
-  else
-    retry_sigaction(FIL__, __LINE__, SIGTSTP,   &ignact, &oldact);
-#endif
-#ifdef SIGTTIN
-  if (goDaemon == 1)
-    retry_sigaction(FIL__, __LINE__, SIGTTIN,     &act2, &oldact);
-  else
-    retry_sigaction(FIL__, __LINE__, SIGTTIN,   &ignact, &oldact);
-#endif
 #else
-#ifdef SIGTSTP
-  retry_sigaction(FIL__, __LINE__, SIGTSTP,   &ignact, &oldact);
-#endif
 #ifdef SIGTTOU
   retry_sigaction(FIL__, __LINE__, SIGTTOU,   &ignact, &oldact);
-#endif
-#ifdef SIGTTIN
-  retry_sigaction(FIL__, __LINE__, SIGTTIN,   &ignact, &oldact);
 #endif
 #endif
@@ -926,8 +819,7 @@
 /* checksum the own binary
  */
-int sh_unix_self_hash (const char * c)
+int sh_unix_self_hash (char * c)
 {
   char message[512];
-  char hashbuf[KEYBUF_SIZE];
 
   SL_ENTER(_("sh_unix_self_hash"));
@@ -941,5 +833,5 @@
 
   sl_strlcpy(sh.exec.hash,
-	     sh_tiger_hash (c, TIGER_FILE, TIGER_NOLIM, hashbuf, sizeof(hashbuf)), 
+	     sh_tiger_hash (c, TIGER_FILE, 0), 
 	     KEY_LEN+1);
   sl_snprintf(message, 512, _("%s has checksum: %s"),
@@ -948,5 +840,7 @@
   sh_error_handle(SH_ERR_INFO, FIL__, __LINE__, 0, MSG_E_SUBGEN,
 		  message, _("sh_unix_self_hash"));
-  if (0 == sl_strcmp(sh.exec.hash, SH_KEY_NULL ))
+  if (0 == sl_strcmp(sh.exec.hash,
+		     _("000000000000000000000000000000000000000000000000")
+		     ))
     {
       dlog(1, FIL__, __LINE__, 
@@ -964,26 +858,15 @@
   char newhash[KEY_LEN+1];
   char message[512];
-  char hashbuf[KEYBUF_SIZE];
 
   SL_ENTER(_("sh_unix_self_check"));
-  if (sh.exec.path[0] == '\0')
+  if (sh.exec.path == NULL || sh.exec.path[0] == '\0')
     SL_RETURN((0), _("sh_unix_self_check"));
 
-  sl_strlcpy(newhash, 
-	     sh_tiger_hash (sh.exec.path, TIGER_FILE, TIGER_NOLIM, hashbuf, sizeof(hashbuf)), 
-	     KEY_LEN+1);
-  if (0 == sl_strncmp(sh.exec.hash, newhash, KEY_LEN))
-    {
-      sh_error_handle(SH_ERR_INFO, FIL__, __LINE__, 0, MSG_E_SUBGEN,
-		      _("Checksum ok"), _("sh_unix_self_check"));
-      SL_RETURN((0), _("sh_unix_self_check"));
-    }
-
-  if (0 == sl_strncmp(SH_KEY_NULL, newhash, KEY_LEN))
-    {
-      sh_error_handle(SH_ERR_WARN, FIL__, __LINE__, 0, MSG_E_SUBGEN,
-		      _("Could not read samhain executable"), _("sh_unix_self_check"));
-      SL_RETURN((0), _("sh_unix_self_check"));
-    }
+  sl_strlcpy(newhash, sh_tiger_hash (sh.exec.path, TIGER_FILE, 0), KEY_LEN+1);
+  if (0 == sl_strncmp(sh.exec.hash, 
+		      newhash,
+		      KEY_LEN))
+    SL_RETURN((0), _("sh_unix_self_check"));
+
  
   dlog(1, FIL__, __LINE__, 
@@ -1006,121 +889,17 @@
 /* ---------------------------------------------------------------- */
 
-long sh_group_to_gid (const char * g, int * fail)
-{
-  struct group *           w;
-  gid_t                    gid  = 0;
-  int                      status = 0;
-
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWNAM_R)
-  struct group     grp;
-  char           * buffer;
-  static size_t    gbufsize = SH_GRBUF_SIZE;       
-#endif
-
-  *fail = -1;
-
-  if (g)
-    {
-      size_t i;
-      size_t len = strlen(g);
-
-      *fail = 0;
-
-      for (i = 0; i < len; ++i)
-	{
-	  char c = g[i];
-
-	  if (!isdigit((int) c))
-	    goto is_a_name;
-	}
-      return atol(g);
-
-    is_a_name:
-
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWNAM_R)
-
-      buffer = SH_ALLOC(gbufsize);
-      status = sh_getgrnam_r(g, &grp, buffer, gbufsize, &w);
-
-      if ((status == ERANGE) && (w == NULL)) 
-	{
-	  if (S_TRUE ==  sl_ok_adds( gbufsize, SH_GRBUF_SIZE ))
-	    {
-	      SH_FREE(buffer);
-	      gbufsize += SH_GRBUF_SIZE;
-	      goto is_a_name;
-	    }
-	}
-
-#else
-
-      errno = 0;
-      w = sh_getgrnam(g);
-      status = errno;
-
-#endif
-
-      if ((status == ERANGE) && (w == NULL)) 
-	{
-	  static int seen = 0;
-	  
-	  if (seen == 0)
-	    {
-	      char errbuf[SH_ERRBUF_SIZE];
-
-	      sh_error_handle (SH_ERR_ERR, FIL__, __LINE__, EINVAL, MSG_E_GRNULL,
-			       sh_error_message(status, errbuf, sizeof(errbuf)),
-			       _("sh_group_to_gid"), (long) -1, _("line too long in group entry"));
-	      ++seen;
-	    }
-	  *fail = -1;
-	}
-      else if (w == NULL)
-	{
-	  char * tmp = sh_util_strdup(g);
-	  sh_error_handle ((-1), FIL__, __LINE__, EINVAL, MSG_EINVALS, 
-			   _("sh_group_to_gid"), tmp);
-	  SH_FREE(tmp);
-	  *fail = -1;
-	}
-      else
-	{
-	  gid = w->gr_gid;
-	}
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWNAM_R)
-      SH_FREE(buffer);
-#endif
-    }
-
-  return gid;
-}
-
-/* ---------------------------------------------------------------- */
-
 
 /* added    Tue Feb 22 10:36:44 NFT 2000 Rainer Wichmann            */
-static int tf_add_trusted_user_int(const char * c)
-{
-  struct passwd *          w;
+static int tf_add_trusted_user_int(char * c)
+{
+  register struct passwd *          w;
   int                           count;
   uid_t                     pwid  = (uid_t)-1;
 
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWNAM_R)
-  struct passwd    pwd;
-  char           * buffer;
-#endif
-  
   SL_ENTER(_("tf_add_trusted_user_int"));
 
   /* First check for a user name.
    */
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWNAM_R)
-  buffer = SH_ALLOC(SH_PWBUF_SIZE);
-  sh_getpwnam_r(c, &pwd, buffer, SH_PWBUF_SIZE, &w);
-#else
-  w = sh_getpwnam(c);
-#endif
-
-  if ((w != NULL) && ((pwid = w->pw_uid) > 0))
+  if ((w = sh_getpwnam(c)) != NULL && ((pwid = w->pw_uid) > 0))
     goto succe;
 	
@@ -1133,33 +912,20 @@
   sh_error_handle ((-1), FIL__, __LINE__, EINVAL, MSG_EINVALS, 
 		   _("add trusted user"), c);
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWNAM_R)
-  SH_FREE(buffer);
-#endif
   SL_RETURN((-1), _("tf_add_trusted_user_int"));
 
  succe:
   count = sl_trust_add_user(pwid);
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWNAM_R)
-  SH_FREE(buffer);
-#endif
   SL_RETURN((count), _("tf_add_trusted_user_int"));
 }
 
-int tf_add_trusted_user(const char * c)
+int tf_add_trusted_user(char * c)
 {
   int    i;
   char * q;
   char * p = sh_util_strdup (c);
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_STRTOK_R)
-  char * saveptr;
-#endif
-
+  
   SL_ENTER(_("tf_add_trusted_user"));
 
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_STRTOK_R)
-  q = strtok_r(p, ", \t", &saveptr);
-#else
   q = strtok(p, ", \t");
-#endif
   if (!q)
     {
@@ -1175,9 +941,5 @@
 	  SL_RETURN((i), _("tf_add_trusted_user"));
 	}
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_STRTOK_R)
-      q = strtok_r(NULL, ", \t", &saveptr);
-#else
       q = strtok(NULL, ", \t");
-#endif
     }
   SH_FREE(p);
@@ -1185,9 +947,9 @@
 }
 
-extern uid_t   sl_trust_baduid(void);
-extern gid_t   sl_trust_badgid(void);
+extern uid_t   sl_trust_baduid();
+extern gid_t   sl_trust_badgid();
 
 #if defined(HOST_IS_CYGWIN) || defined(__cygwin__) || defined(__CYGWIN32__) || defined(__CYGWIN__)
-int tf_trust_check (const char * file, int mode)
+int tf_trust_check (char * file, int mode)
 {
   (void) file;
@@ -1196,5 +958,5 @@
 }
 #else
-int tf_trust_check (const char * file, int mode)
+int tf_trust_check (char * file, int mode)
 {
   char * tmp;
@@ -1203,7 +965,5 @@
   int    status;
   int    level;
-  uid_t  ff_euid = (uid_t) -1;
-  uid_t  baduid;
-  gid_t  badgid;
+  uid_t  ff_euid;
 
   SL_ENTER(_("tf_trust_check"));
@@ -1217,12 +977,5 @@
   if (0 == sl_ret_euid())   /* privileges not dropped yet */
     {
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWNAM_R)
-      struct passwd    pwd;
-      char          *  buffer = SH_ALLOC(SH_PWBUF_SIZE);
-      struct passwd *  tempres;
-      sh_getpwnam_r(DEFAULT_IDENT, &pwd, buffer, SH_PWBUF_SIZE, &tempres);
-#else
       struct passwd * tempres = sh_getpwnam(DEFAULT_IDENT);
-#endif
 
       if (!tempres)
@@ -1233,11 +986,5 @@
 	  aud_exit (FIL__, __LINE__, EXIT_FAILURE);
 	}
-      else
-	{
-	  ff_euid = tempres->pw_uid;
-	}
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWNAM_R)
-      SH_FREE(buffer);
-#endif
+      ff_euid = tempres->pw_uid;
     }
 #endif
@@ -1252,12 +999,9 @@
 	level = SH_ERR_ERR;
 
-      tmp    = sh_util_safe_name (file);
-      p      = sh_util_strdup(sl_trust_errfile());
-      baduid = sl_trust_baduid();
-      badgid = sl_trust_badgid();
-      
+      tmp  = sh_util_safe_name (file);
+      p    = sl_trust_errfile();
       if (p && *p != '\0')
 	{
-	  tmp2  = sh_util_safe_name (p);
+	  tmp2  = sh_util_safe_name (sl_trust_errfile());
 	  sh_error_handle(level, FIL__, __LINE__, status, MSG_E_TRUST2,
 			  sl_error_string(status), tmp, tmp2);
@@ -1269,4 +1013,5 @@
 			  sl_error_string(status), tmp);
 	}
+      SH_FREE(tmp);
 
       if (status == SL_EBADUID   || status == SL_EBADGID || 
@@ -1280,35 +1025,41 @@
 	    break;
 	  case SL_ETRUNC:
+	    tmp  = sh_util_safe_name (file);
 	    dlog(1, FIL__, __LINE__, 
 		 _("A filename truncation occured in the trustfile function.\nProbably the normalized filename for %s\nis too long. This may be due e.g. to deep or circular softlinks.\n"), 
 		 tmp);
+	    SH_FREE(tmp);
 	    break;
 	  case SL_EBADOTH:
+	    tmp  = sh_util_safe_name (file);
+	    p    = sl_trust_errfile();
 	    dlog(1, FIL__, __LINE__, 
 		 _("The path element: %s\nin the filename: %s is world writeable.\n"),
-		 (p) ? p : _("(null)"), tmp);
+		 p, tmp);
+	    SH_FREE(tmp);
 	    break;
 	  case SL_EBADUID:
+	    tmp  = sh_util_safe_name (file);
+	    p    = sl_trust_errfile();
 	    dlog(1, FIL__, __LINE__, 
 		 _("The owner (UID = %ld) of the path element: %s\nin the filename: %s\nis not in the list of trusted users.\nTo fix the problem, you can:\n - run ./configure again with the option --with-trusted=0,...,UID\n   where UID is the UID of the untrusted user, or\n - use the option TrustedUser=UID in the configuration file.\n"),
-		 (UID_CAST)baduid, (p) ? p : _("(null)"), tmp);
+		 (UID_CAST)sl_trust_baduid(), p, tmp);
+	    SH_FREE(tmp);
 	    break;
 	  case SL_EBADGID:
+	    tmp  = sh_util_safe_name (file);
+	    p    = sl_trust_errfile();
 	    dlog(1, FIL__, __LINE__, 
 		 _("The path element: %s\nin the filename: %s\nis group writeable (GID = %ld), and at least one of the group\nmembers (UID = %ld) is not in the list of trusted users.\nTo fix the problem, you can:\n - run ./configure again with the option --with-trusted=0,...,UID\n   where UID is the UID of the untrusted user, or\n - use the option TrustedUser=UID in the configuration file.\n"),
-		 (p) ? p : _("(null)"), tmp, (UID_CAST)badgid, 
-		 (UID_CAST)baduid);
+		 p, tmp, (UID_CAST)sl_trust_badgid(), 
+		 (UID_CAST)sl_trust_baduid());
+	    SH_FREE(tmp);
 	    break;
 	  default:
 	    break;
 	  }
-	  SH_FREE(tmp);
-	  if (p) SH_FREE(p);
+	    
 	  SL_RETURN((-1), _("tf_trust_check"));
 	}
-      else {
-	SH_FREE(tmp);
-	if (p) SH_FREE(p);
-      }
     }
 
@@ -1346,13 +1097,14 @@
 
 #ifdef HAVE_INITGROUPS
-char *  sh_unix_getUIDname (int level, uid_t uid, char * out, size_t len);
+char *  sh_unix_getUIDname (int level, uid_t uid);
 int  sh_unix_initgroups2 (uid_t in_pid, gid_t in_gid)
 {
   int status  = -1;
-  char user[SH_MINIBUF];
+  char * user = NULL;
 
   SL_ENTER(_("sh_unix_initgroups2"));
 
-  if (NULL == sh_unix_getUIDname (SH_ERR_ERR, in_pid, user, sizeof(user)))
+  user = sh_unix_getUIDname (SH_ERR_ERR, in_pid);
+  if (user == NULL)
     SL_RETURN((-1), _("sh_unix_initgroups2"));
   status = sh_initgroups (user, in_gid);
@@ -1375,5 +1127,5 @@
 #endif
 
-void sh_unix_closeall (int fd, int except, int inchild)
+void sh_unix_closeall (int fd, int except)
 {
   int fdx = fd;
@@ -1393,13 +1145,8 @@
    */
   if (fdlimit < 0)
-    fdlimit = 20;  /* POSIX lower limit */
+    fdlimit = 8;  /* POSIX lower limit */
 
   if (fdlimit > 65536)
     fdlimit = 65536;
-
-  if (!inchild)
-    sl_dropall (fdx, except);
-  else
-    sl_dropall_dirty (fdx, except);
 
   /* Close everything from fd (inclusive) up to fdlimit (exclusive). 
@@ -1412,6 +1159,8 @@
 	fd++;
       else
-	sl_close_fd(FIL__, __LINE__, fd++);
-    }
+	close(fd++);
+    }
+
+  sl_dropall (fdx, except);
 
   SL_RET0(_("sh_unix_closeall"));
@@ -1444,4 +1193,9 @@
 #ifdef RLIMIT_NPROC
   setrlimit (RLIMIT_NPROC,   &limits);
+#endif
+#if defined(RLIMIT_NOFILE)
+  setrlimit (RLIMIT_NOFILE,  &limits);
+#elif defined(RLIMIT_OFILE)
+  setrlimit (RLIMIT_OFILE,   &limits);
 #endif
 #ifdef RLIMIT_MEMLOCK
@@ -1463,12 +1217,4 @@
 #endif
 
-  limits.rlim_cur = 1024;
-  limits.rlim_max = 1024;
-
-#if defined(RLIMIT_NOFILE)
-  setrlimit (RLIMIT_NOFILE,  &limits);
-#elif defined(RLIMIT_OFILE)
-  setrlimit (RLIMIT_OFILE,   &limits);
-#endif
 
   SL_RET0(_("sh_unix_setlimits"));
@@ -1480,5 +1226,4 @@
   char ** env1;
   int   envlen = 0;
-  size_t len;
 
   SL_ENTER(_("sh_unix_copyenv"));
@@ -1491,5 +1236,5 @@
 
   /* printf("-> %2d: slots allocated\n", envlen); */
-  env1 = calloc(1,sizeof(char *) * envlen);      /* only once */
+  env1 = malloc (sizeof(char *) * envlen);      /* only once */
   if (env1 == NULL)
     {
@@ -1500,16 +1245,12 @@
   envlen = 0;
 
-  while (env0 != NULL && env0[envlen] != NULL) {
-    len = strlen(env0[envlen]) + 1;
-    env1[envlen] = calloc(1,len); /* only once */
+  while (env0 != NULL && env0[envlen] != NULL) { 
+    env1[envlen] = malloc (strlen(env0[envlen]) + 1); /* only once */
     if (env1[envlen] == NULL)
       {
-	int i;
 	fprintf(stderr, _("%s: %d: Out of memory\n"), FIL__, __LINE__);
-	for (i = 0; i < envlen; ++i) free(env1[len]);
-	free(env1);
 	SL_RET0(_("sh_unix_copyenv"));
       }
-    sl_strlcpy(env1[envlen], env0[envlen], len);
+    strcpy(env1[envlen], env0[envlen]);                /* known to fit  */
     ++envlen;
   }
@@ -1543,26 +1284,10 @@
 	continue;
       }
-    if (0 == sl_strncmp((*env), _("MYSQL_TCP_PORT="), 15))
-      {
-	++(env);
-	continue;
-      }
-    if (0 == sl_strncmp((*env), _("MYSQL_HOME="), 11))
-      {
-	++(env);
-	continue;
-      }
 #endif
 #ifdef WITH_ORACLE
     /* 
-     * Skip the ORACLE_HOME and TNS_ADMIN environment variables; 
-     * Oracle may need them.
+     * Skip the ORACLE_HOME environment variable; Oracle may need it.
      */
     if (0 == sl_strncmp((*env), _("ORACLE_HOME="), 12))
-      {
-	++(env);
-	continue;
-      }
-    if (0 == sl_strncmp((*env), _("TNS_ADMIN="), 10))
       {
 	++(env);
@@ -1589,8 +1314,4 @@
   }
 
-#ifdef HAVE_TZSET
-  tzset();
-#endif
-
   SL_RET0(_("sh_unix_zeroenv"));
 }
@@ -1627,9 +1348,6 @@
 #endif
   int  test;
+  struct sigaction act, oldact;
   int  status;
-  struct sigaction act;
-#if !defined(SH_PROFILE)
-  struct sigaction oldact;
-#endif
 
   sigset_t set_proc;
@@ -1644,5 +1362,5 @@
   do {
     errno = 0;
-    test  = SH_SETSIGMASK(SIG_UNBLOCK, &set_proc, NULL);
+    test  = sigprocmask(SIG_UNBLOCK, &set_proc, NULL);
   } while (test < 0 && errno == EINTR);
 
@@ -1664,8 +1382,7 @@
       if ((test == -1) && (errno != EINVAL)) 
 	{
-	  char errbuf[SH_ERRBUF_SIZE];
 	  status = errno;
 	  sh_error_handle ((-1), FIL__, __LINE__, status, MSG_W_SIG,
-			   sh_error_message (status, errbuf, sizeof(errbuf)), sig_num);
+			   sh_error_message (status), sig_num);
 	}
     }
@@ -1676,18 +1393,4 @@
 /* Get the local hostname (FQDN)
  */
-static char * sh_tolower (char * s)
-{
-  char * ret = s;
-  if (s)
-    {
-      for (; *s; ++s)
-	{ 
-	  *s = tolower((unsigned char) *s);
-	}
-    }
-  return ret;
-}
-
-
 #include <sys/socket.h> 
 
@@ -1699,18 +1402,4 @@
 
 #include <arpa/inet.h>
-
-const char * sh_unix_h_name (struct hostent * host_entry)
-{
-	char ** p;
-	if (strchr(host_entry->h_name, '.')) {
-		return host_entry->h_name;
-	} else {
-		for (p = host_entry->h_aliases; *p; ++p) {
-			if (strchr(*p, '.'))
-				return *p;
-		}
-	}
-	return host_entry->h_name;
-}
 
 /* uname() on FreeBSD is broken, because the 'nodename' buf is too small
@@ -1722,11 +1411,10 @@
 {
   struct utsname   buf;
+  struct hostent * he1;
   int              i;
-  unsigned int     ddot;
+  int              ddot = 0;
   int              len;
   char           * p;
   char             hostname[256];
-  char             numeric[SH_IP_BUF];
-  char           * canonical;
 
 
@@ -1734,5 +1422,5 @@
 
   (void) uname (&buf);
-  /* flawfinder: ignore */ /* ff bug, ff sees system() */
+
   sl_strlcpy (sh.host.system,  buf.sysname, SH_MINIBUF);
   sl_strlcpy (sh.host.release, buf.release, SH_MINIBUF);
@@ -1774,34 +1462,37 @@
     }
 
-  canonical = sh_ipvx_canonical(hostname, numeric, sizeof(numeric));
-
-  if (canonical == NULL)
-    {
+  he1 = sh_gethostbyname(hostname);
+
+  if (he1 == NULL)
+    {
+      dlog(1, FIL__, __LINE__, 
+	   _("According to uname, your nodename is %s, but your resolver\nlibrary cannot resolve this nodename to a FQDN. For more information, see the entry about self-resolving under 'Most frequently' in the FAQ that you will find in the docs/ subdirectory.\n"),
+	   hostname);
       sl_strlcpy (sh.host.name, hostname,    SH_PATHBUF);
-      sh_tolower (sh.host.name);
     }
   else
     {
-      sl_strlcpy (sh.host.name, canonical,   SH_PATHBUF);
-      SH_FREE(canonical);
-    }
+      sl_strlcpy (sh.host.name, he1->h_name, SH_PATHBUF);
+    }
+  
 
   /* check whether it looks like a FQDN
    */
   len = sl_strlen(sh.host.name);
-  ddot = 0;
   for (i = 0; i < len; ++i) 
     if (sh.host.name[i] == '.') ++ddot; 
 
-  if (ddot == 0)
+  if (ddot == 0 && he1 != NULL)
     { 
       dlog(1, FIL__, __LINE__, 
 	   _("According to uname, your nodename is %s, but your resolver\nlibrary cannot resolve this nodename to a FQDN.\nRather, it resolves this to %s.\nFor more information, see the entry about self-resolving under\n'Most frequently' in the FAQ that you will find in the docs/ subdirectory.\n"),
 	   hostname, sh.host.name);
-      sl_strlcpy (sh.host.name, numeric, SH_PATHBUF);
+      sl_strlcpy (sh.host.name, 
+		  inet_ntoa (*(struct in_addr *) he1->h_addr), 
+		  SH_PATHBUF);
       SL_RET0(_("sh_unix_localhost"));
     } 
 
-  if (sh_ipvx_is_numeric(sh.host.name)) 
+  if (is_numeric(sh.host.name)) 
     {
       dlog(1, FIL__, __LINE__, 
@@ -1812,49 +1503,31 @@
   SL_RET0(_("sh_unix_localhost"));
 }
-
 #else
-
-/* 
- * --FreeBSD code 
- */
-#if defined(HAVE_UNAME)
-#include <sys/utsname.h>
-#endif
 void sh_unix_localhost()
 {
-#if defined(HAVE_UNAME)
-  struct utsname   buf;
-#endif
+  struct hostent * he1;
   int              i;
-  int              ddot;
+  int              ddot = 0;
   int              len;
   char             hostname[1024];
-  char             numeric[SH_IP_BUF];
-  char           * canonical;
+
 
   SL_ENTER(_("sh_unix_localhost"));
-
-#if defined(HAVE_UNAME)
-  (void) uname (&buf);
-  /* flawfinder: ignore */ /* ff bug, ff sees system() */
-  sl_strlcpy (sh.host.system,  buf.sysname, SH_MINIBUF);
-  sl_strlcpy (sh.host.release, buf.release, SH_MINIBUF);
-  sl_strlcpy (sh.host.machine, buf.machine, SH_MINIBUF);
-#endif
 
   (void) gethostname (hostname, 1024);
   hostname[1023] = '\0';
-
-  canonical = sh_ipvx_canonical(hostname, numeric, sizeof(numeric));
-
-  if (canonical == NULL)
-    {
-      sl_strlcpy (sh.host.name, hostname, SH_PATHBUF);
-      sh_tolower (sh.host.name);
+  he1 = sh_gethostbyname(hostname);
+
+  if (he1 != NULL)
+    {
+      sl_strlcpy (sh.host.name, he1->h_name, SH_PATHBUF);
     }
   else
     {
-      sl_strlcpy (sh.host.name, canonical,   SH_PATHBUF);
-      SH_FREE(canonical);
+      dlog(1, FIL__, __LINE__, 
+	   _("According to gethostname, your nodename is %s, but your resolver\nlibrary cannot resolve this nodename to a FQDN.\nFor more information, see the entry about self-resolving under\n'Most frequently' in the FAQ that you will find in the docs/ subdirectory.\n"),
+	   hostname);
+      sl_strlcpy (sh.host.name, _("localhost"), SH_PATHBUF);
+      SL_RET0(_("sh_unix_localhost"));
     }
 
@@ -1862,5 +1535,4 @@
    */
   len = sl_strlen(sh.host.name);
-  ddot = 0;
   for (i = 0; i < len; ++i) 
     if (sh.host.name[i] == '.') ++ddot; 
@@ -1870,9 +1542,11 @@
 	   _("According to uname, your nodename is %s, but your resolver\nlibrary cannot resolve this nodename to a FQDN.\nRather, it resolves this to %s.\nFor more information, see the entry about self-resolving under\n'Most frequently' in the FAQ that you will find in the docs/ subdirectory.\n"),
 	   hostname, sh.host.name);
-      sl_strlcpy (sh.host.name, numeric, SH_PATHBUF);
+      sl_strlcpy (sh.host.name, 
+		  inet_ntoa (*(struct in_addr *) he1->h_addr), 
+		  SH_PATHBUF);
       SL_RET0(_("sh_unix_localhost"));
     }
 
-  if (sh_ipvx_is_numeric(sh.host.name)) 
+  if (is_numeric(sh.host.name)) 
     {
       dlog(1, FIL__, __LINE__, 
